Developer Hub
Request Demo
Request Demo
Support
  1. Purposes
  • Getting Started
    • Introduction
  • API Reference
    • Admins
      • Bulk Admins Download API
    • Business Owners
      • Bulk Business Owners Download API
      • Bulk Business Owners Upload API
    • Configuration
      • Bulk Entity Finding Rules Download API
      • Bulk Custom Insights (Entity Rules) Download API
      • Bulk Filters Download API
      • Bulk Findings Download API
      • Get Branding Information
    • Employees
      • Bulk Employees Download API
      • Bulk Employees Upload API
    • Entitlements
      • Bulk Entitlements Download API
      • Bulk Entitlements Upload API
    • Entities
      • Bulk Entities Download API
      • Bulk Entities Upload API
      • Bulk Entities + Entity-Relations Zip Upload API
    • EntityInsights
      • Bulk Entity Insights Download API
    • EntityRelations
      • Bulk Entity Relations Download API
      • Bulk Entity Relations Upload API
    • EntityRBAC
      • Bulk Entity RBAC Download API
    • Integrations
      • Bulk Integrations Download API
    • Purposes
      • Bulk Purposes Download API
        POST
    • Relations
      • Bulk Relations Upload API
    • Requests
      • Bulk Requests Download API
    • Reviews
      • Bulk Reviews Download API
  • Relations
    • Bulk Employee Relations Upload API
      POST
    • Bulk Employee Relations Download API
      POST
  • Schemas
    • Schemas
      • AdminsDownloadURLRequest
      • BusinessOwnersDownloadURLRequest
      • EntitiesDownloadURLRequest
      • EntitiesUploadURLRequest
      • EntitlementDownloadURLRequest
      • EntitlementUploadURLRequest
      • EntityRelationsDownloadURLRequest
      • EntityRelationsUploadURLRequest
      • Error
      • FindingsDownloadURLRequest
      • UploadURLResponse
    • DownloadURLResponse
    • EmployeeRelationsDownloadURLRequest
    • ReviewDownloadURLRequest
    • RequestsDownloadURLRequest
    • EntitiesBulkUploadURLRequest
    • Logo
    • BrandingResponse
  1. Purposes

Bulk Purposes Download API

POST
https://balkanid.app/api/rest/v0/purposes/download-url

BalkanID Purposes Download CSV Format#

In this section, we will explain the BalkanID Purposes CSV format.

Sample CSV#

BRN*Purpose Name*Description*Pre-Expiry NotificationDepartmentJob TitleTeamOwnerBirthrightEntity BRNs
brn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:purpose:01JH1JR91K9N91Z04PHK2201WRKubernetes DevelopmentPurpose which is meant for Kubernetes Development168hSoftware DevelopmentSoftware Development EngineerSoftwareaali@example.comDepartment Birthrightbrn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:identity:04giq7jlHzhHyZ-cOvAn4Fn2dNc3bjqZrK4ufzx19Q0, brn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:identity:04giq7jlHzhHyZ-cOvAn4Fn2dNc3bjqZrK4ufzx19Q1
brn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:purpose:01JH1JR91K9N91Z04PHK2201WPInfrastructure DevOpsPurpose which is meant for Infrastucture DevOps168hDevOpsDevOps EngineerDevOpsmgomez@example.comDepartment Birthrightbrn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:identity:04giq7jlHzhHyZ-cOvAn4Fn2dNc3bjqZrK4ufzx19Q2, brn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:identity:04giq7jlHzhHyZ-cOvAn4Fn2dNc3bjqZrK4ufzx19Q3
brn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:purpose:01JH1JR91K9N91Z04PHK2201WQProduction OncallPurpose which is meant for Production Oncall2hCustomer SupportCustomer SupportCustomer Supportxliu@example.comTeam Birthrightbrn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:identity:04giq7jlHzhHyZ-cOvAn4Fn2dNc3bjqZrK4ufzx19Q4
brn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:purpose:01JH1JR91K9N91Z04PHK2201WSLocal Stack DevelopmentPurpose which is meant for Local Stack Development48hSoftware DevelopmentSoftware Development EngineerSoftwarefasaud@example.comOrganization Birthrightbrn:bid:balkanid:::01HWBCYJA11R3AA48K5V0DVM00:identity:04giq7jlHzhHyZ-cOvAn4Fn2dNc3bjqZrK4ufzx19Q0
Columns with * are required always.
Column Definitions#
Column NameColumn Description
BRNRequired - Balkan Resource Name
Purpose NameRequired - Name of the purpose
DescriptionRequired - Description of the purpose
Pre-Expiry NotificationTime duration before expiry of purpose request at which a notification is sent out
DepartmentDepartment associated to the purpose
Job TitleJob Title associated to the purpose
TeamTeam associated to the purpose
OwnerOwner of the entity
BirthrightBirthright that the purpose represents
Entity BRNsComma separated list of Entity BRNs that are granted access to when starting a purpose
"BRN", "Purpose Name" and "Description" are required columns.
The only valid values for "Pre-Expiry Notification" are '', '2h', '4h', '24h', '48h', '168h'.

Download the CSV file via the pre-signed URL#

After retrieving the pre-signed URL in the previous step, all that remains is to download the CSV in BalkanID Purposes CSV format from the pre-signed URL.
To use the polling URL, first send an HTTP request with the method HEAD to the pollingUrl.
If the response status code is 404, the file is not ready, and you should retry this polling request after a delay.
If the response status code is 200, the file is ready, and you may proceed to download the CSV from the received url.

Request

Authorization
API Key
Add parameter in header
X-API-KEY-ID
Example:
X-API-KEY-ID: ********************
API Key
Add parameter in header
X-API-KEY-SECRET
Example:
X-API-KEY-SECRET: ********************
or
Header Params

Request Code Samples

Shell
JavaScript
Java
Swift
Go
PHP
Python
HTTP
C
C#
Objective-C
Ruby
OCaml
Dart
R
Request Request Example
Shell
JavaScript
Java
Swift
curl --location --request POST 'https://balkanid.app/api/rest/v0/purposes/download-url' \
--header 'X-Api-Key-ID;' \
--header 'X-Api-Key-Secret;' \
--header 'X-API-KEY-ID: <api-key>' \
--header 'X-API-KEY-SECRET: <api-key>' \
--header 'Content-Type: application/json'

Responses

🟢200OK
application/json
download url response
Bodyapplication/json

Example
{
    "url": "string",
    "pollingUrl": "string"
}
⚪defaultServer Error
Modified at 2026-11-06 13:38:07
Previous
Bulk Integrations Download API
Next
Bulk Relations Upload API
Built with